<?php
namespace Teknisa\PLA\Modules\Cardapio\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;

class Pla11800ReplicacaoMensalDoCardapioController {
    protected $environment;
    protected $util;
    protected $Pla11800ReplicacaoMensalDoCardapioService;
    
    public function __construct($util, $environment, $Pla11800ReplicacaoMensalDoCardapioService) {
        $this->util = $util;
        $this->environment = $environment;
        $this->Pla11800ReplicacaoMensalDoCardapioService = $Pla11800ReplicacaoMensalDoCardapioService;
    }

    public function retornaServicos(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $listaFilal = $this->util->criarListaValores($row['CDFILIAL']);
            $listaGrupServ = $this->util->criarListaValores($row['CDGRUPSERV']);

            $params = array(
                'P_CDFILIAL' => $listaFilal,
                'P_CDGRUPSERV' => $listaGrupServ,
                'P_DTCARDAPIO' => $row['CARDORIG'],
                'P_CDGRUPFILI' => $row['CDGRUPFILI']
            );

            $servicos = $this->Pla11800ReplicacaoMensalDoCardapioService->getServicos($params);

            $response->addDataSet(new DataSet('servicos', $servicos));
            
            $this->util->apagarListaValores($listaFilal);
            $this->util->apagarListaValores($listaGrupServ);
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), 1));
        }
    }

    public function callReplicaCardapioPlaProcedure(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();

            foreach ($row['P_SERVICOS'] as $e) {
                $e = "_NRLISTA=".$e;
            }

            foreach ($row['P_MAPADIAS'] as $e) {
                $e = "_NRLISTA=".$e;
            }

            $listaServ = $this->util->insertLista($row['P_SERVICOS']);
            $listaMapaDias = $this->util->insertLista($row['P_MAPADIAS']);

            $params = array(
                'P_DTCARDORI' => $row['P_DTCARDORI'],
                'P_SERVICOS' => $listaServ,
                'P_MAPADIAS' => $listaMapaDias,
                'P_CDOPERADOR' => $row['P_CDOPERADOR'],
                'P_CDFILIALLOGADA' => $row['P_CDFILIALLOGADA'],
                'P_NRORG' => $row['P_NRORG'],
            );

            $listaErros = $this->Pla11800ReplicacaoMensalDoCardapioService->replicaCardapioPlaProcedure($params);

            if ($listaErros['P_LISTAERROS'] != null || $listaErros['P_LISTAERROS'] != '') {
                $response->addDataSet(new DataSet('lista_erros', [$listaErros['P_LISTAERROS']]));
            } else {
                $response->addDataSet(new DataSet('mensagem', ['replicacaoRealizadaSucesso']));
            }

            $this->util->apagarListaValores($listaServ);
            $this->util->apagarListaValores($listaMapaDias);
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), 1));
        }
    }
}